/**
 * Eine Partie "Vier Gewinnt".
 * 
 * @author Selina M., Bianca R., Lara R., Sophie T.
 * @author Bernd Gramlich
 * @version 2014-12-25
 */
public class Spiel
{
    /*
     * Die Namen der gelben und der roten Spielerin.
     */
    private String gelb;
    private String rot;

    /*
     * Welche Farbe ist als nchste dran?
     */
    private String naechsteFarbe;

    /*
     * Die sieben Schchte des Spielfelds.
     */
    private Spalte[] schacht;

    /*
     * Der Name der Gewinnerin.
     */
    private String gewinnerin;

    /**
     * Konstruktor.
     * Starte ein Spiel mit ersterName als gelbe und zweiterName als
     * rote Spielerin.
     */
    public Spiel (String ersterName, String zweiterName)
    {
        naechsteFarbe = "rot";

        gelb = ersterName;
        rot  = zweiterName;

        gewinnerin = null;

        schacht = new Spalte [7];

        for (int i = 0; i <= 6; i++)
        {
            schacht [i] = new Spalte ();
        }
    }

    /**
     * Wirf fr die angegebene Spielerin einen Chip in den
     * angegebenen Schacht.
     */
    public Ergebnis wirfEin (String name, int spaltennummer)
    {
        Ergebnis rueckgabe = Ergebnis.WEITER;

        if ((naechsteFarbe.equals ("rot") && name.equals (gelb))
            || (naechsteFarbe.equals ("gelb") && name.equals (rot)))
        {
            if (spaltennummer >= 0 && spaltennummer <= 7)
            {
                if (schacht [spaltennummer].spalteVoll ())
                {   
                    rueckgabe = Ergebnis.VOLL;
                }
                else
                {
                    if (naechsteFarbe.equals ("rot"))
                    {
                        naechsteFarbe = "gelb";
                    }
                    else 
                    {
                        naechsteFarbe = "rot";
                    }
                    schacht [spaltennummer].wirfEin (naechsteFarbe);

                    if (hatVierGleiche ())
                    {
                        if (naechsteFarbe.equals ("rot"))
                        {
                            rueckgabe = Ergebnis.ROT;
                        }
                        else
                        {
                            rueckgabe = Ergebnis.GELB;
                        }
                        
                        gewinnerin = name;
                    }
                    else if (alleSpaltenVoll ())
                    {
                        rueckgabe = Ergebnis.UNENTSCHIEDEN;
                    }
                    else
                    {
                        rueckgabe = Ergebnis.WEITER;
                    }
                }
            }
            else
            {
                rueckgabe = Ergebnis.UNGUELTIG;
            }  
        }
        else
        {
            rueckgabe = Ergebnis.NICHT_DRAN;
        }

        return rueckgabe;
    }

    /**
     * Prfe ob 4 gleiche Chips in einer Reihe sind.
     */
    private boolean hatVierGleiche ()
    {
        boolean gefunden = false;

        for (int i = 0; i <= 3; i++)
        {
            for (int j = 0; j <= 6; j++)
            {
                if (schacht[i].gibFarbe (j) == schacht[i+1].gibFarbe (j) && schacht[i].gibFarbe (j) == schacht[i+2].gibFarbe (j) && schacht[i].gibFarbe (j) == schacht[i+3].gibFarbe (j))
                {
                    gefunden = true;
                }
            }
        }

        { 
            for (int i = 0; i <= 6; i++)
            {
                for (int j = 0; j <= 3; j++)
                {
                    {
                        if (schacht[i].gibFarbe (j) == schacht[i].gibFarbe (j+1) && schacht[i].gibFarbe (j) == schacht[i].gibFarbe (j+2) && schacht[i].gibFarbe (j) == schacht[i].gibFarbe (j+3))
                        {
                            gefunden = true;
                        }
                    }
                }
            }
        }

        {
            for (int i = 0; i <= 3; i++)
            {
                for  (int j = 0; j <= 6; j++)
                {
                    {
                        if  (schacht[i].gibFarbe (j) == schacht[i+1].gibFarbe (j+1) && schacht[i].gibFarbe (j) == schacht[i+2].gibFarbe (j+2) && schacht[i].gibFarbe (j) == schacht[i+3].gibFarbe (j+3))
                        {
                            gefunden = true;
                        }
                    }
                }
            }
        }

        {
            for (int i = 0; i <= 3; i++)
            {
                for  (int j = 0; j <= 6; j++)
                {
                    {
                        if  (schacht[i+3].gibFarbe (j) == schacht[i+2].gibFarbe (j+1) && schacht[i+3].gibFarbe (j) == schacht[i+1].gibFarbe (j+2) && schacht[i+3].gibFarbe (j) == schacht[i].gibFarbe (j+3))
                        {
                            gefunden = true;
                        }
                    }
                }
            }
        }
        
        return gefunden;
    }

    /**
     * Prfe, ob alle Spalten voll sind.
     */ 
    private boolean alleSpaltenVoll ()
    {
        boolean gefunden = true;

        for (int i = 0; i <= 6; i++)
        {
            if (!schacht[i].spalteVoll ())
            {
                gefunden = false;
            }
        }

        return gefunden;
    }

    /**
     * Nenne den Namen der Gewinnerin.
     */
    public String gibGewinnerin ()
    {
        return gewinnerin;
    }
}